Domcom FAQ

* How big is Domcom?

  About 21K+ after the current minimization. A total of about 500 lines of code for src/7.coffee source files.

* What types and browsers does Domcom support?

  Same as React.

* Is there an external library that Domcom relies on?

  React and ReactDOM are required.

* Is there a conflict between using Domcom and directly operating Dom?

  This requires caution. The good news is that after using Domcom, you can basically eliminate the need to directly operate Dom. Regardless, unless there is a real need and you already know the internals of domcom, please be careful not to directly manipulate Domcom managed Dom nodes, including using native APIs or library programs such as jQuery. Of course this does not include Dom nodes that are not generated by Domcom.

* Domcom need a supporting library to complete the MVC mode?

  Simply put, no need. If there are special needs, Domcom can work with other libraries more easily and better.

  Similar to ReactJS, Domcom is a framework focused on View. But the two are significantly different in data binding and delivery and update mechanisms. This difference makes Domcom not need to use immutable data and other auxiliary libraries to make up for the defects in the framework. Domcom does not require the use of the specified Model class and Controller and its derived classes as the frameworks such as Backbone or EmberJS. Nor does it require the Model to be included in the Scope level as in AngularJS. It is managed by a dedicated Controller, and does not even require data like ReactJS. Organized into props and state hierarchies, defining the Controller method as a component method. The Domcom application is the most free choice for Model and Controller solutions. The most common Javascript language features (such as variables, functions, common classes and objects) can be easily integrated into Domcom as data binding and data. The tool passed. In most cases, not using a dedicated auxiliary library is the most appropriate option. These features can be learned from Domcom's [todomvc] (https://github.com/taijiweb/domcom/blob/master/demo/coffee/todomvc.coffee) demo. Of course, in the face of special needs, Domcom can also be well integrated with the existing libraries.


  This advantage can shorten the process of learning and using Domcom, reduce the learning curve, and reduce the complexity of the application and reduce the amount of code.

* Does Domcom have its own template language?

  No additional template language is required to use Domcom, because the nested array `[tag, {...props}, ...children]` syntax using the js language is more concise.